## DAVPrincipal

Description

A class for things to do with a DAV Principal

Located in /inc/DAVPrincipal.php (line 19)

    Principal
       |
       --DAVPrincipal

Variable Summary
RFC3744: $_is_group
Method Summary
boolean __construct ([mixed $parameters = null])
void addressbook_home_set ()
void AsCollection ()
void calendar_free_busy_set ()
void calendar_home_set ()
void FetchProxyGroups ()
string GetProperty ( $property_id)
void GroupMemberSet ()
void GroupMembership ()
void InitialiseRecord (object $usr)
boolean IsGroup ()
void PrincipalProperty ( $tag, $prop, &$reply, &$denied)
void Privileges ()
void PropertySearch ( $parameters)
void ProxyFor (string $type)
void ReadProxyGroup ()
string RenderAsXML (array $properties, &$reply, [boolean $props_only = false], reference $reply)
void unique_tag ()
void WriteProxyGroup ()
Variables
RFC3744: $_is_group (line 42)

- var: The principals that are direct members of this group.
- access: protected

#### Inherited Variables

Inherited from Principal

> Principal::$by_email
> Principal::$collections
> Principal::$collection_id
> Principal::$created
> Principal::$date_format_type
> Principal::$dav_name
> Principal::$dead_properties
> Principal::$default_calendar
> Principal::$default_privileges
> Principal::$displayname
> Principal::$email
> Principal::$email_ok
> Principal::$exists
> Principal::$fullname
> Principal::$is_addressbook
> Principal::$is_calendar
> Principal::$is_principal
> Principal::$locale
> Principal::$modified
> Principal::$original_request_url
> Principal::$password
> Principal::$principal_id
> Principal::$privileges
> Principal::$resourcetypes
> Principal::$type_id
> Principal::$url
> Principal::$username
> Principal::$user_active
> Principal::$user_no

Methods
Constructor __construct (line 95)

Constructor

- return: Whether we actually read data from the DB to initialise the record.

boolean __construct ([mixed $parameters = null])

- mixed $parameters: If null, an empty Principal is created. If it is an integer then that ID is read (if possible). If it is an array then the Principal matching the supplied elements is read. If it is an object then it is expected to be a 'usr' record that was read elsewhere.

Redefinition of:

Principal::__construct()
  Construct a new Principal object. The principal record will be retrieved from the database, or (if not found) initialised to a new record. You can test for whether the Principal exists by calling the Exists() method on the returned object.

addressbook_home_set (line 359)

Get the addressbook_home_set, as lazily as possible

void addressbook_home_set ()
AsCollection (line 420)

Returns a representation of the principal as a collection

void AsCollection ()
calendar_free_busy_set (line 382)

Get the calendar_free_busy_set, as lazily as possible

void calendar_free_busy_set ()
calendar_home_set (line 336)

Get the calendar_home_set, as lazily as possible

void calendar_home_set ()
FetchProxyGroups (line 194)

Split this out so we do it as infrequently as possible, given the cost.

void FetchProxyGroups ()
GetProperty (line 303)

Return an arbitrary property

- return: The name of the arbitrary property

string GetProperty ( $property_id)

- $property_id

GroupMemberSet (line 284)

Accessor for the group member set - the members of this group

void GroupMemberSet ()
GroupMembership (line 275)

Accessor for the group membership - the groups this principal is a member of

void GroupMembership ()
InitialiseRecord (line 144)

Initialise the Principal object from a $usr record from the DB.

void InitialiseRecord (object $usr)

- object $usr: The usr record from the DB.

IsGroup (line 294)

Is this a group principal?

- return: Whether this is a group principal

boolean IsGroup ()
PrincipalProperty (line 451)

Returns properties which are specific to this principal

void PrincipalProperty ( $tag, $prop, &$reply, &$denied)

- $tag
- $prop
- &$reply
- &$denied

Privileges (line 404)

Return the privileges bits for the current session user to this resource

void Privileges ()
PropertySearch (line 444)
void PropertySearch ( $parameters)

- $parameters

ProxyFor (line 265)

Accessor for read or write proxy

void ProxyFor (string $type)

- string $type: read/write - which sort of proxy list is requested.

ReadProxyGroup (line 246)

Accessor for the read proxy group

void ReadProxyGroup ()
RenderAsXML (line 569)

Render XML for a single Principal (user) from the DB

- return: An XML fragment with the requested properties for this principal

string RenderAsXML (array $properties, &$reply, [boolean $props_only = false], reference $reply)

- array $properties: The requested properties for this principal
- reference $reply: A reference to the XMLDocument being used for the reply
- boolean $props_only: Default false. If true will only return the fragment with the properties, not a full response fragment.
- &$reply

unique_tag (line 324)

Returns the unique_tag (ETag or getctag) for this resource

- access: public

void unique_tag ()
WriteProxyGroup (line 255)

Accessor for the write proxy group

void WriteProxyGroup ()

#### Inherited Methods

Inherited From Principal

> Principal::__construct()
> Principal::byEmail()
> Principal::cacheDelete()
> Principal::cacheFlush()
> Principal::Create()
> Principal::dav_name()
> Principal::default_calendar()
> Principal::email()
> Principal::Exists()
> Principal::FetchCollections()
> Principal::FetchDeadProperties()
> Principal::internal_url()
> Principal::principal_id()
> Principal::setUsername()
> Principal::unCache()
> Principal::Update()
> Principal::updateableFields()
> Principal::url()
> Principal::username()
> Principal::user_no()
> Principal::__get()
> Principal::__isset()

Documentation generated on Fri, 13 Jan 2012 23:44:54 +1300 by phpDocumentor 1.4.3